Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | File List | Class Members | File Members

# InformationRecovery Class Reference

`#include <ida.h>`

Inheritance diagram for InformationRecovery:

List of all members.

## Detailed Description

a variant of Rabin's Information Dispersal Algorithm

Definition at line 115 of file ida.h.

## Public Member Functions
| InformationRecovery (int threshold, BufferedTransformation *attachment=NULL, bool removePadding=true)
void | IsolatedInitialize (const NameValuePairs &parameters=g_nullNameValuePairs)
unsigned int | GetThreshold () const
void | AddOutputChannel (word32 channelId)
void | ChannelData (word32 channelId, const byte *inString, unsigned int length, bool messageEnd)
unsigned int | InputBuffered (word32 channelId) const
unsigned int | ChannelPut2 (const std::string &channel, const byte *begin, unsigned int length, int messageEnd, bool blocking)
void | SetAutoSignalPropagation (int propagation)
| set propagation of automatically generated and transferred signals
int | GetAutoSignalPropagation () const
bool | Flush (bool completeFlush, int propagation=-1, bool blocking=true)
| flush buffered input and/or output
bool | IsolatedFlush (bool hardFlush, bool blocking)
bool | ChannelFlush (const std::string &channel, bool hardFlush, int propagation=-1, bool blocking=true)
bool | MessageSeriesEnd (int propagation=-1, bool blocking=true)
| mark end of a series of messages
byte * | CreatePutSpace (unsigned int &size)
| request space which can be written into by the caller, and then used as input to Put()
unsigned int | Put2 (const byte *begin, unsigned int length, int messageEnd, bool blocking)
| input multiple bytes for blocking or non-blocking processing
unsigned int | PutModifiable2 (byte *inString, unsigned int length, int messageEnd, bool blocking)
| input multiple bytes that may be modified by callee for blocking or non-blocking processing
byte * | ChannelCreatePutSpace (const std::string &channel, unsigned int &size)
bool | ChannelPutModifiable (const std::string &channel, byte *inString, unsigned int length)
unsigned int | ChannelPutModifiable2 (const std::string &channel, byte *begin, unsigned int length, int messageEnd, bool blocking)
bool | Attachable ()
| returns whether this object allows attachment
BufferedTransformation * | AttachedTransformation ()
| returns the object immediately attached to this object or NULL for no attachment
const BufferedTransformation * | AttachedTransformation () const
void | Detach (BufferedTransformation *newAttachment=NULL)
| delete the current attachment chain and replace it with newAttachment
unsigned int | TransferTo2 (BufferedTransformation &target, unsigned long &transferBytes, const std::string &channel=NULL_CHANNEL, bool blocking=true)
unsigned int | CopyRangeTo2 (BufferedTransformation &target, unsigned long &begin, unsigned long end=ULONG_MAX, const std::string &channel=NULL_CHANNEL, bool blocking=true) const
void | Initialize (const NameValuePairs &parameters=g_nullNameValuePairs, int propagation=-1)
| initialize or reinitialize this object
BufferedTransformation & | Ref ()
| return a reference to this object
virtual std::string | AlgorithmName () const
| returns name of this algorithm, not universally implemented yet
virtual Clonable * | Clone () const
| this is not implemented by most classes yet
bool | Wait (unsigned long milliseconds)
| wait on this object
## Static Public Attributes
const std::string | NULL_CHANNEL
## Protected Member Functions
void | FlushOutputQueues ()
void | OutputMessageEnds ()
unsigned int | InsertInputChannel (word32 channelId)
unsigned int | LookupInputChannel (word32 channelId) const
void | ComputeV (unsigned int)
void | PrepareInterpolation ()
void | ProcessInputQueues ()
virtual bool | InputBufferIsEmpty () const
virtual BufferedTransformation * | NewDefaultAttachment () const
void | Insert (Filter *nextFilter)
virtual bool | ShouldPropagateMessageEnd () const
virtual bool | ShouldPropagateMessageSeriesEnd () const
void | PropagateInitialize (const NameValuePairs &parameters, int propagation)
unsigned int | Output (int outputSite, const byte *inString, unsigned int length, int messageEnd, bool blocking, const std::string &channel=NULL_CHANNEL)
unsigned int | OutputModifiable (int outputSite, byte *inString, unsigned int length, int messageEnd, bool blocking, const std::string &channel=NULL_CHANNEL)
bool | OutputMessageEnd (int outputSite, int propagation, bool blocking, const std::string &channel=NULL_CHANNEL)
bool | OutputFlush (int outputSite, bool hardFlush, int propagation, bool blocking, const std::string &channel=NULL_CHANNEL)
bool | OutputMessageSeriesEnd (int outputSite, int propagation, bool blocking, const std::string &channel=NULL_CHANNEL)
## Static Protected Member Functions
int | DecrementPropagation (int propagation)
## Protected Attributes
bool | m_pad
ByteQueue | m_queue
std::map< word32, unsigned int > | m_inputChannelMap
std::map< word32, unsigned int >::iterator | m_lastMapPosition
std::vector< MessageQueue > | m_inputQueues
std::vector< word32 > | m_inputChannelIds
std::vector< word32 > | m_outputChannelIds
std::vector< word32 > | m_outputToInput
std::vector< std::string > | m_outputChannelIdStrings
std::vector< ByteQueue > | m_outputQueues
int | m_threshold
unsigned int | m_channelsReady
unsigned int | m_channelsFinished
std::vector< SecBlock< word32 > > | m_v
SecBlock< word32 > | m_u
SecBlock< word32 > | m_w
SecBlock< word32 > | m_y
unsigned int | m_inputPosition
int | m_continueAt

## Member Function Documentation

void AutoSignaling< Unflushable< Multichannel< Filter > > >::SetAutoSignalPropagation | ( | int | propagation | ) | `[inline, virtual, inherited]`

| Reimplemented from BufferedTransformation. Definition at line 168 of file simple.h.

bool Unflushable< Multichannel< Filter > >::Flush | ( | bool | completeFlush,
|  | int | propagation = `-1`,
|  | bool | blocking = `true`
| ) | `[inline, virtual, inherited]`

| Reimplemented from Multichannel< Filter >. Definition at line 71 of file simple.h.

bool Multichannel< Filter >::MessageSeriesEnd | ( | int | propagation = `-1`,
|  | bool | blocking = `true`
| ) | `[inline, virtual, inherited]`

| Reimplemented from Filter. Definition at line 138 of file simple.h.

byte* Multichannel< Filter >::CreatePutSpace | ( | unsigned int & | size | ) | `[inline, virtual, inherited]`

| Reimplemented from BufferedTransformation. Definition at line 140 of file simple.h.

unsigned int Multichannel< Filter >::Put2 | ( | const byte * | begin,
|  | unsigned int | length,
|  | int | messageEnd,
|  | bool | blocking
| ) | `[inline, virtual, inherited]`

| Implements BufferedTransformation. Definition at line 142 of file simple.h.

unsigned int Multichannel< Filter >::PutModifiable2 | ( | byte * | inString,
|  | unsigned int | length,
|  | int | messageEnd,
|  | bool | blocking
| ) | `[inline, virtual, inherited]`

| Reimplemented from BufferedTransformation. Definition at line 144 of file simple.h.

bool Filter::Attachable | ( |  | ) | `[inline, virtual, inherited]`

| returns whether this object allows attachment Some BufferedTransformation objects (e.g. Filter objects) allow other BufferedTransformation objects to be attached. When this is done, the first object instead of buffering its output, sents that output to the attached object as input. The entire attachment chain is deleted when the anchor object is destructed. Reimplemented from BufferedTransformation. Definition at line 19 of file filters.h.

BufferedTransformation& BufferedTransformation::Ref | ( |  | ) | `[inline, inherited]`

| return a reference to this object This function is useful for passing a temporary BufferedTransformation object to a function that takes a non-const reference. Definition at line 711 of file cryptlib.h.

unsigned long BufferedTransformation::MaxRetrievable | ( |  | ) | const`[virtual, inherited]`

| returns number of bytes that is currently ready for retrieval All retrieval functions return the actual number of bytes retrieved, which is the lesser of the request number and MaxRetrievable(). Reimplemented in FileStore, RandomNumberStore, NullStore, MessageQueue, ByteQueue, and RandomPool. Definition at line 247 of file cryptlib.cpp. References BufferedTransformation::AttachedTransformation(), and BufferedTransformation::CopyTo(). Referenced by RandomNumberStore::AnyRetrievable(), and Integer::BERDecode().

bool BufferedTransformation::GetNextMessage | ( |  | ) | `[virtual, inherited]`

| start retrieving the next message Returns false if no more messages exist or this message is not completely retrieved. Reimplemented in MessageQueue, and Store. Definition at line 336 of file cryptlib.cpp. References BufferedTransformation::AnyMessages(), and BufferedTransformation::AttachedTransformation().

bool Waitable::Wait | ( | unsigned long | milliseconds | ) | `[inherited]`

| wait on this object same as creating an empty container, calling GetWaitObjects(), and calling Wait() on the container Definition at line 321 of file wait.cpp. References Waitable::GetWaitObjects(), and WaitObjectContainer::Wait(). Referenced by NetworkSource::GeneralPump2(), and NetworkSink::TimedFlush().

The documentation for this class was generated from the following file:

- ida.h